#!/usr/bin/perl

# /usr/local/bin/matrixrcv.pl
# Dieses Programm überwacht die serielle Schnittstelle und wartet auf das Poweroff-Kommando von der Matrixuhr.
# Anschließend wird der Raspberry Pi der Matrixuhr heruntergefahren.
# Scott-Falk Hühn, 04.06.2018

use strict;
use warnings;

my $senif = "/dev/serial0";              # Serielle Schnittstelle des Raspberry Pi
my $sensor = "/usr/local/bin/sensor.pl"; # Pfad zum Programm sensor.pl
my $SER;                                 # Dateihandle der seriellen Schnittstelle

system("stty -F $senif 9600 -echo");                          # Baudrate einstellen und Echo ausschalten

if (!(-e $sensor)) {                                          # wenn Sensor-Dienst nicht installiert
  while (1) {                                                 # Endlosschleife
    open($SER, "<$senif") or die $!;                          # serielle Schnittstelle zum Lesen öffnen
    while (<$SER>) {                                          # wenn ein Datenpaket empfangen wurde
      chomp($_);                                              # Steuerzeichen entfernen
      if ($_ =~ /^Poweroff$/) {                               # wenn Poweroff-Kommando
        close($SER);                                          # serielle Schnittstelle schließen
        system("systemctl stop matrixuhr");                   # Matrixuhr-Dienst stoppen
        sleep 1;                                              # 1 Sekunde warten
        open($SER, ">$senif") or die $!;                      # serielle Schnittstelle zum Schreiben öffnen
        print $SER "\n\n";                                    # 2x Zeilenende senden
        print $SER "A1:101Poweroff\n";                        # "Poweroff" als Alarmmeldung (kein Sound, halten) senden
        print $SER "A1:0\n";                                  # Alarm wieder löschen
        system("systemctl poweroff");                         # System herunterfahren
        exit;                                                 # Programm beenden
      }
    }
    close($SER);                                              # Schleife neu starten, falls EOT (4) empfangen wird
  }
}
