#!/bin/bash

# /usr/local/bin/matrixres.sh
# Dieses Programm überwacht einen Taster am Pin 11 (GPIO 17). Bei einem Tastendruck von 2 Sekunden wird eine
# Bestätigung zur Matrixuhr gesendet und anschließend der Raspberry Pi heruntergefahren.
# Scott-Falk Hühn, 10.07.2022

ser="/dev/serial0"      # serielle Schnittstelle
pin=17                  # GPIO-Pin für Poweroff-Taster

sleep 30
pigs m $pin r
pigs pud $pin u
sleep 1
while true
do
  val=$( pigs r $pin )
  sleep 1
  if [ "$val" = "0" ]
  then
    val=$( pigs r $pin )
    if [ "$val" = "0" ]
    then
      sudo systemctl stop matrixuhr
      sleep 1
      stty -F $ser 9600 -echo
      sleep 1
      echo -e "\n\nA1:101Poweroff\n" > $ser
      echo -e "A1:0\n" > $ser
      sudo systemctl poweroff
      break
    fi
  fi
done
